{

  open Parse_tree

}


rule token = parse
  | [' ''\t''\n'] { token lexbuf }
  | '(' { LP }
  | ')' { RP }
  | '[' { LB }
  | ']' { RB }
  | ',' { C }
  | ';' { SC }
  | ['0'-'9']+ as s { I(int_of_string s) }
  | 'U' { U }
  | 'L' { L }
  | 'N' { N }
  | _ as c { failwith ("bad character " ^ (String.make 1 c)) }

