

%token<int> I
%token LP RP LB RB C SC U L N 

%type<Ast.dump_tree> tree
%start tree

%%

tree:
| U 
    { Ast.U }
| L LP I C I RP 
    { Ast.L($3,$5,[]) }
| L LP I C I C LB pv RB RP 
    { Ast.L($3,$5,$8) }
| L LP I C I LB pv RB RP 
    { Ast.L($3,$5,$7) }
| N LP I C I C I C I C LB list RB RP
    { Ast.N($3,$5,$7,$9,$12) }
;


list:
| /* epsilon */
    { [] }
| LP I C I C tree RP SC list
    { ($2,$4,$6)::$9 }
;

pv:
| /* epsilon */
    { [] }
| LP I C I C I C I RP SC pv
    { ($2,$4,$6,$8)::$11 }
| LP I C I C I I RP SC pv
    { ($2,$4,$6,$7)::$10 }
| LP I C I C I RP SC pv
    { let x = $6 in 
      ($2,$4,x / 10,x mod 10)::$9 }
;
