
open Format

(* reading the solution from a file *)

type solution = (int*int) array array

let load n file sol =
  for i = 0 to n-1 do for j = 0 to n-1 do 
    sol.(i).(j) <- (-1,0) 
  done done;
  let c = open_in file in
  try
    while true do
      let s = input_line c in
      try
	Scanf.sscanf s "i=%d j=%d p=%d rot=%d" 
	  (fun i j p r -> 
	     assert (fst sol.(i).(j) == -1);
	     sol.(i).(j) <- (p,r))
      with Scanf.Scan_failure s -> 
	eprintf "Scan_failure: %s@." s; exit 1
    done
  with End_of_file ->
    close_in c
      
let save n sol file =
  let c = open_out file in
  let fmt = formatter_of_out_channel c in
  for i = 0 to n-1 do
    for j = 0 to n-1 do
      let (p,r) = sol.(i).(j) in
      if p >= 0 then
	fprintf fmt "i=%d j=%d p=%d rot=%d@." i j p r
    done
  done;
  close_out c
