
open Format

let i = ref 7
let j = ref 7

let pos = Array.create 255 (0,0)

let store =
  let k = ref (-1) in
  fun () -> 
    incr k;
    pos.(!k) <- !i,!j

let up () = incr i
let down () = decr i
let right () = incr j
let left () = decr j
let repeat n f = for i = 1 to n do f (); store () done

let () =
  for k = 1 to 15 do
    if k mod 2 = 1 then begin
      repeat k up; repeat k right;
    end else begin 
      repeat k down; repeat k left
    end
  done;
  repeat 15 down

let () = 
  Array.iter (fun (i,j) -> printf "%d,%d " i j) pos;
  printf "@."
