
(* [f x y s p] draws pattern [p] at [x,y] and scale [s];
   assumption: [0 <= p <= 22] *)

val right : int -> int -> int -> int -> unit
val up : int -> int -> int -> int -> unit
val left : int -> int -> int -> int -> unit
val down : int -> int -> int -> int -> unit

val piece : int -> int -> int -> Puzzle.piece -> unit

val open_board : ?title:string -> ?lines:bool -> int -> unit
